{$A+,B-,D+,E-,F-,G+,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y-}
{$M 16384,0,655360}
{Programm SPLIT - teilt Dateien in 1,4 MB kleine Haeppchen auf

 Autor: Martin Vogel
        Stockumer Str. 445
        44227 Dortmund
        martin.vogel@ruhr-uni-bochum.de
        http://www.martinvogel.de

}

uses dos;

var ein, aus:file;
var bat:text;
var nr:integer;
var p:array[0..32767] of byte;
var dateinummer:integer;
var gelesen:word;
var ps:pathstr;
var ns:namestr;
var es:extstr;
var maxk:longint;
var kzulesen:longint;




{*********************************************************************}
{ Dreistellige Dateiendung mit fuehrenden Nullen                      }
{*********************************************************************}
function nullnull(i:integer):string;
var s:string;
begin
  str(i,s);
  while length(s)<3 do s:='0'+s;
  nullnull:='.'+s;
end;

{*********************************************************************}
{ String in Integerzahl wandeln                                       }
{*********************************************************************}
Function ATOI(s:string):Longint;
var    i:longint;
   dummy:integer;
begin
  val(s,i,dummy);
  atoi:=i;
end;


{*********************************************************************}
{ Hauptprogramm SPLIT                                                 }
{*********************************************************************}
begin
  writeln('SPLIT (c) 1999, 2002 Martin Vogel -  http://www.martinvogel.de');

  if paramcount<1 then
  begin
    writeln('Name der zu splittenden Datei fehlt!');
    halt(1);
  end;

  maxk:=atoi(paramstr(2));
  if maxk<1 then maxk:=1423;
  Writeln('Groesse der Teilstuecke: ',maxk,' KByte (',maxk*1024,' Byte)');


  assign(ein,paramstr(1));
  filemode:=2;
  reset(ein,1);
  if ioresult<>0 then
  begin
    writeln('Kann Eingabedatei nicht oeffnen.');
    halt(1);
  end;
  filemode:=0;
  fsplit(paramstr(1),ps,ns,es);
  writeln(ps+ns+es);
  writeln('--');
  dateinummer:=0;

  repeat
    inc(dateinummer);
    writeln(ps+ns+nullnull(dateinummer));
    assign(aus,ps+ns+nullnull(dateinummer));
    rewrite(aus,1);
    kzulesen:=maxk;
    repeat
      if kzulesen>32
      then blockread(ein,p,32768,gelesen)
      else blockread(ein,p,kzulesen*1024,gelesen);
      dec(kzulesen,32);
      blockwrite(aus,p,gelesen);
    until (gelesen=0) or (kzulesen<1);
    close(aus);
  until gelesen=0;
  close(ein);
  writeln('--');
  writeln(ps+ns+'.bat');
  assign(bat,ps+ns+'.bat');
  rewrite(bat);
  write(bat,'COPY /b '+ns+'.001');
  for nr:=2 to dateinummer do
    write(bat,'+'+ns+nullnull(nr));
  writeln(bat,' '+ns+es);
  close(bat);
  writeln('ok');
end.


